source: udev-lfs/rule_generator.functions@ b2b1e1a

10.0 10.0-rc1 10.1 10.1-rc1 11.0 11.0-rc1 11.0-rc2 11.0-rc3 11.1 11.1-rc1 11.2 11.2-rc1 11.3 11.3-rc1 12.0 12.0-rc1 12.1 12.1-rc1 7.3 7.4 7.5 7.5-systemd 7.6 7.6-systemd 7.7 7.7-systemd 7.8 7.8-systemd 7.9 7.9-systemd 8.0 8.1 8.2 8.3 8.4 9.0 9.1 arm bdubbs/gcc13 ml-11.0 multilib renodr/libudev-from-systemd s6-init trunk xry111/arm64 xry111/arm64-12.0 xry111/clfs-ng xry111/lfs-next xry111/loongarch xry111/loongarch-12.0 xry111/loongarch-12.1 xry111/mips64el xry111/pip3 xry111/rust-wip-20221008 xry111/update-glibc
Last change on this file since b2b1e1a was b2b1e1a, checked in by Bruce Dubbs <bdubbs@…>, 12 years ago

Move directory to make build easier

git-svn-id: http://svn.linuxfromscratch.org/LFS/trunk/BOOK@9973 4aa44e1e-78dd-0310-a6d2-fbcd4c07a689

  • Property mode set to 100644
File size: 3.5 KB
Line 
1# functions used by the udev rule generator
2
3# Copyright (C) 2006 Marco d'Itri <md@Linux.IT>
4# Updated for LFS by Bruce Dubbs <bdubbs@linuxfromscratch.org>
5# Hardcoded RUNDIR
6
7# This program is free software: you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation, either version 2 of the License, or
10# (at your option) any later version.
11
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16
17# You should have received a copy of the GNU General Public License
18# along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20PATH='/usr/bin:/bin:/usr/sbin:/sbin'
21
22# Read a single line from file $1 in the $DEVPATH directory.
23# The function must not return an error even if the file does not exist.
24sysread() {
25 local file="$1"
26 [ -e "/sys$DEVPATH/$file" ] || return 0
27 local value
28 read value < "/sys$DEVPATH/$file" || return 0
29 echo "$value"
30}
31
32sysreadlink() {
33 local file="$1"
34 [ -e "/sys$DEVPATH/$file" ] || return 0
35 readlink -f /sys$DEVPATH/$file 2> /dev/null || true
36}
37
38# Return true if a directory is writeable.
39writeable() {
40 if ln -s test-link $1/.is-writeable 2> /dev/null; then
41 rm -f $1/.is-writeable
42 return 0
43 else
44 return 1
45 fi
46}
47
48# Create a lock file for the current rules file.
49lock_rules_file() {
50 RUNDIR=/run/udev
51 [ -e "$RUNDIR" ] || return 0
52
53 RULES_LOCK="$RUNDIR/.lock-${RULES_FILE##*/}"
54
55 retry=30
56 while ! mkdir $RULES_LOCK 2> /dev/null; do
57 if [ $retry -eq 0 ]; then
58 echo "Cannot lock $RULES_FILE!" >&2
59 exit 2
60 fi
61 sleep 1
62 retry=$(($retry - 1))
63 done
64}
65
66unlock_rules_file() {
67 [ "$RULES_LOCK" ] || return 0
68 rmdir $RULES_LOCK || true
69}
70
71# Choose the real rules file if it is writeable or a temporary file if not.
72# Both files should be checked later when looking for existing rules.
73choose_rules_file() {
74 RUNDIR=/run/udev
75 local tmp_rules_file="$RUNDIR/tmp-rules--${RULES_FILE##*/}"
76 [ -e "$RULES_FILE" -o -e "$tmp_rules_file" ] || PRINT_HEADER=1
77
78 if writeable ${RULES_FILE%/*}; then
79 RO_RULES_FILE='/dev/null'
80 else
81 RO_RULES_FILE=$RULES_FILE
82 RULES_FILE=$tmp_rules_file
83 fi
84}
85
86# Return the name of the first free device.
87raw_find_next_available() {
88 local links="$1"
89
90 local basename=${links%%[ 0-9]*}
91 local max=-1
92 for name in $links; do
93 local num=${name#$basename}
94 [ "$num" ] || num=0
95 [ $num -gt $max ] && max=$num
96 done
97
98 local max=$(($max + 1))
99 # "name0" actually is just "name"
100 [ $max -eq 0 ] && return
101 echo "$max"
102}
103
104# Find all rules matching a key (with action) and a pattern.
105find_all_rules() {
106 local key="$1"
107 local linkre="$2"
108 local match="$3"
109
110 local search='.*[[:space:],]'"$key"'"('"$linkre"')".*'
111 echo $(sed -n -r -e 's/^#.*//' -e "${match}s/${search}/\1/p" \
112 $RO_RULES_FILE \
113 $([ -e $RULES_FILE ] && echo $RULES_FILE) \
114 2>/dev/null)
115}
Note: See TracBrowser for help on using the repository browser.